#include <stdlib.h>
#include <dos.h>
#include <stdio.h>

#ifndef __ZTC__
	#ifdef M_I86
		#include <malloc.h>
	#else
		#include <alloc.h>
	#endif
#endif

#include <conio.h>
#include <time.h>
#include "uw.h"
#include "uw_globx.h"
#include "uw_keys.h"

#define NUM_WINS 26

typedef struct fields_struct						/* structure for field input to the	*/
{																				/* order form function!							*/
	int		num_fields;											/* total number of fields						*/
	char	*input[10];                     /* strings for the result						*/
	char	*mask[10];                      /* masks for display on the screen	*/
	char	*template[10];                  /* tempatess for validation					*/
	int		x[10];                          /* positions for the input					*/
	int		y[10];
	int		strip[10];                      /* strip masks on result?						*/
} FIELDS;

char *Enque_strs[] =
{
	"EnQue Software",
	"Route 1, Box 116C",
	"Pleasant Hill, MO, 64080",
	"BBS (816) 353-0991",
	"(Voice 5-10pm and weekends)"
};
char	*Prices[] = { "20.00", "30.00" };
char	Package[10] = "2", Name[40], Address[40], City[30], State[10],
			Zip[10], Phone[20], Password[10];

int tmp();

WINDOW	Main_wn;
WINDOW 	Back_wn, *Back_wnp = &Back_wn;
MENU		Top_menu, *Top_mnp = &Top_menu;
MENU    Terminal_menu, Setup_menu, Window_menu, Files_menu;
MENU		*Drop_mnps[4];

main()
{
	int i, r;
	WINDOW *wnp;

	wnp = &Main_wn;
	init_video(80, 25);
	init_mouse();
	wn_create( 0, 3, V_cols-1, V_rows-1, NO_BDR, WN_NORMAL, wnp );
	wn_color( YELLOW, BLUE, wnp );
	wn_bdr_color( YELLOW, BLUE, wnp );
	wn_name("Main_wn", wnp);
	add_window(wnp);
	title_screen();
	wn_plst( CENTERED, (V_rows / 2) - 1, "Welcome to the UltraWin Library!", wnp );
	wait();

	wn_clear(wnp);
	wn_color( BLUE, LIGHTGRAY, wnp );
	wn_plst(1, 0, "    Speed it one of many features incorporated into the UltraWin Library.     ", wnp );
	wn_plst(1, 1, "   Here is a list of the main features, all of which will be demonstrated!    ", wnp );

	wn_color( YELLOW, BLUE, wnp );
	wn_hline(2,SGL_BDR,wnp);
	r = 3;
	wn_plst(0, r++, "1) Complete range of windowing functions to dynamically create, update,", wnp );
	wn_plst(0, r++, "   move, and destroy an unlimited number of windows.", wnp );
	r++;
	wn_plst(0, r++, "2) A Window Manager that will handle all the hard work when multiple", wnp );
	wn_plst(0, r++, "   windows are on the screen.", wnp );
	r++;
	wn_plst(0, r++, "3) Each window is fully buffered. Output to a window can take place at any", wnp );
	wn_plst(0, r++, "   time, even if another window overlaps it.  This is perhaps, the", wnp );
	wn_plst(0, r++, "   most impressive feature. Windows can scroll output even if overlapped!", wnp );
	r++;
	wn_plst(0, r++, "4) Powerful string and data entry capabilities.", wnp );
	wn_plst(0, r++, "5) Powerful menuing capability with full mouse support!", wnp );
	r++;
	wn_plst(0, r++, "6) The library supports virtually any video board, including 43/50", wnp );
	wn_plst(0, r++, "   row EGA/VGA mode. It even works with non-standard modes i.e. 132*60.", wnp );
	r++;
	wn_hline(r,SGL_BDR,wnp);
	r += 2;
	wn_color( WHITE, BLUE | 8, wnp );
	wn_plst(CENTERED, r++, "<<< FOLLOW ALONG AS WE TAKE YOU THROUGH ALL OF THESE FEATURED AND MORE! >>", wnp );
	wait();
	wn_color_demo();
	wn_create_demo();
	wn_line_demo();
	wn_scroll_demo();
	wn_entry_demo();
	wn_menu_demo();
	wait();
	wn_destroy(wnp);
	end_mouse();
	end_video();
}

/*****************/
/* ~wn_line_demo */
/*               ************************************************************/
/****************************************************************************/
wn_line_demo()
{
	int i, t, x, y;
	WINDOW wn;

	wn_clear(&Main_wn);
	/*----------------- demonstrate line drawing capabilities ----------------*/
	wn_prompt("UltraWin has several border styles...");
	wn_create( 17, 7, 59, 19, SGL_BDR, WN_NORMAL, &wn );
	wn_color( BLACK, CYAN, &wn );
	wn_bdr_color( BLACK, CYAN, &wn );
	wn_set(&wn);
	for( t = 0; t < 3; t++ )
	{
		for( i = 0; i <= 4; i++ )
		{
			wn.bdr_style = i;
			wn_border(&wn);
			wait_ticks( (clock_t) 6 );
		}
	}
	wn_prompt("UltraWin has line drawing capabilities....");
	wn.bdr_style = SGL_BDR;
	wn_border(&wn);

	wn_hline(2,DBL_BDR,&wn);
	wait_ticks( (clock_t) 6 );
	wn_hline(4,SGL_BDR,&wn);
	wait_ticks( (clock_t) 6 );
	wn_vline(4,DBL_BDR,&wn);
	wait_ticks( (clock_t) 6 );
	wn_hline(8,DBL_BDR,&wn);
	wait_ticks( (clock_t) 6 );
	wn_vline(40,SGL_BDR,&wn);
	wait_ticks( (clock_t) 6 );
	wn_hline(6,SGL_BDR,&wn);
	wait_ticks( (clock_t) 6 );
	wn_vline(22,SGL_BDR,&wn);
	wait_ticks( (clock_t) 6 );
	wait();
	wn_clear(&wn);
	wn_border(&wn);
	wn_color( YELLOW, CYAN, &wn );
	wn_color( RED, CYAN, &wn );
	wn_plst( 0, 1, "  1     2     3     4     5     6     7 ", &wn );
	wn_plst( 0, 4, "  8     9    10    11    12    13    14 ", &wn );
	wn_plst( 0, 7, " 15     16   17    18    19    20    21 ", &wn );
	wn_plst( 0,10, " 22     23   24    25    26    27    28 ", &wn );
	wn_color( BLACK, CYAN, &wn );
	for( x = 5; x < 40; x += 6 )
		wn_vline(x, SGL_BDR, &wn);
	for( y = 2; y < 11; y += 3 )
		wn_hline(y, SGL_BDR, &wn);
	wn_color( BLUE, LIGHTGRAY, &wn );
	wn.inside = 0;
	wn_plst( 0, 0, "   S     M     T     W     T     F     S   ", &wn );
	wn.inside = 1;
	wait();
	wn_destroy(&wn);
}
/*** end of wn_line_demo ***/

/******************/
/* ~wn_entry_demo */
/*                ***********************************************************/
/****************************************************************************/
wn_entry_demo()
{
	int			i, stat, end_flag = OFF,
					m_att = ((CYAN << 4) | YELLOW),
					wn_att = ((CYAN << 4) | WHITE),
					bdr_att = ((CYAN << 4) | BLACK);
	char  	*package_m, *package_t, buffer[80];
	WINDOW	wn, *wnp = &wn;
	FIELDS	f;

	wn_clear(&Main_wn);
/*---------------------- demonstrate entry capabilities --------------------*/
	wn_prompt("UltraWin has flexible data entry support...");

	package_m		= "_";
	package_t		= "#";
  f.input[0]		= Name;
	f.x[0]				= 23, f.y[0] = 10, f.strip[0] = ON;
	f.mask[0]			= "___________________________________";
	f.template[0]	= "AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA";
  f.input[1]		= Address;
	f.x[1]				= 23, f.y[1] = 11, f.strip[1] = ON;
	f.mask[1]     = "___________________________________";
	f.template[1] = "***********************************";
	f.input[2]		= City;
	f.x[2]				= 23, f.y[2] = 12, f.strip[2] = ON;
	f.mask[2]     = "____________________";
  f.template[2] = "UAAAAAAAAAAAAAAAAAAA";
  f.input[3]		= State;
	f.x[3]				= 52, f.y[3] = 12, f.strip[3] = ON;
	f.mask[3]     = "__";
	f.template[3] = "UU";
	f.input[4]		= Zip;
	f.x[4]				= 62, f.y[4] = 12, f.strip[4] = ON;
	f.mask[4]     = "_____";
	f.template[4] = "#####";
	f.input[5]		= Phone;
	f.x[5]				= 23, f.y[5] = 13, f.strip[5] = OFF;
	f.mask[5]     = "(___) ___-____";
	f.template[5] = " ###  ### ####";
	f.input[6]		= Password;
	f.x[6]				= 23, f.y[6] = 14, f.strip[6] = ON;
	f.mask[6]     = "________";
	f.template[6] = "AAAAAAAA";

	wn_create(2, 4, 77, 23, DBL_BDR, WN_NORMAL, wnp);
	wn.bdr_att = bdr_att;
	wn.att = wn_att;
	wn_name("< UltraWIN Order Form >", wnp);
  m_hide();
	add_window(wnp);
	for (i=0; i<5; i++)
		wn_plst(2, i + 2, Enque_strs[i], wnp);

	wn_plst(4,   8, "Yes, I want to order package #  at $  .  .  Please mail to:", wnp);
	wn_plst(10, 10, "        Name:", wnp);
	wn_plst(10, 11, "     Address:", wnp);
	wn_plst(10, 12, "        City:                      State:    Zip:", wnp);
	wn_plst(10, 13, "       Phone:", wnp);
	wn_plst(10, 14, "BBS Password:", wnp);

	wnp->att = m_att;
	for (i=0; i<7; i++)
	{
		wn_plst(f.x[i], f.y[i], f.mask[i], wnp);
		wn_plst(f.x[i], f.y[i], f.input[i], wnp);
	}
	wnp->att = bdr_att;
	wn_plst(11, 17, "Press <1> or <2> and <Enter>, or press <Esc> to cancel", wnp);
	m_show();
	mv_cs(34, 8, wnp), stat = wn_gets(Package, package_m, package_t, m_att, 1, &wn);
	if ( stat == KEY_ESC )
	{
		m_hide(), remove_window(wnp), m_show();
		return(0);
	}
	m_hide();
	wn_plst(6, 17, "Please enter the following fields, pressing PgDn when complete", wnp);
	wnp->att = m_att;
	f.num_fields = 7;
	if (Package[0] == '1')
	{
		wn_plst(40, 8, Prices[0], wnp);
		wnp->att = bdr_att;
		wn_plst(38, 1, "Package #1: (libraries only)", wnp);
		wn_plst(38, 2, "  1) Large Model Libraries", wnp);
		wn_plst(38, 3, "  2) Updated Documentation", wnp);
		wn_plst(38, 4, "  3) Example Programs", wnp);
		wn_plst(38, 5, "  4) Support Via the EnQue BBS", wnp);
	} else
	{
		Package[0] = '2', Package[1] = 0;
		wn_plst(40, 8, Prices[1], wnp);
		wn_plst(34, 8, Package, wnp);
		wnp->att = bdr_att;
		wn_plst(38, 1, "Package #2 (libraries + source):", wnp);
		wn_plst(38, 2, "  1) Large Model Libraries", wnp);
		wn_plst(38, 3, "  2) Updated Documentation", wnp);
		wn_plst(38, 4, "  3) Example Programs", wnp);
		wn_plst(38, 5, "  4) Support Via the EnQue BBS", wnp);
		wn_plst(38, 6, "  5) Full Source Code!", wnp);
		wnp->att = wn_att;
	}
	m_show();
	i = 0;
	while (!end_flag)
	{
		mv_cs(f.x[i], f.y[i], wnp);
		stat = wn_gets(f.input[i], f.mask[i], f.template[i],
									 m_att, f.strip[i], wnp);
		switch(stat)
		{
			case KEY_UP:
				if (--i < 0)
					i = f.num_fields - 1;
				break;
		  case KEY_ENTER:
				if (++i >= f.num_fields)
				  end_flag = ON;
				break;
			case KEY_DN: case KEY_TAB:
				if (++i >= f.num_fields)
					i = 0;
		  	break;
			case KEY_PGUP: case KEY_PGDN:
			  end_flag = ON;
				break;
			case KEY_ESC: case -1:
				m_hide(), remove_window(wnp), m_show();
				return(0);
		}
	}
	m_hide(), remove_window(wnp), m_show();
}

/******************/
/* ~wn_color_demo */
/*                ***********************************************************/
/****************************************************************************/
wn_color_demo()
{
	int i, x, xs, ys, new_att, old_att;
	char buff[81];
	WINDOW *wns[8], *wnp;
	static char *names[8] = { "<< Window 0 >>", "<< Window 1 >>",
	 "<< Window 2 >>", "<< Window 3 >>", "<< Window 4 >>",
	 "<< Window 5 >>", "<< Window 6 >>", "<< Window 7 >>" };

	wn_clear(&Main_wn);
	wn_prompt("Let's demonstrate UltraWin's color capabilities...");
	for( i = 0; i < 8; i++ )
		wns[i] = calloc(1,sizeof(WINDOW));
	for( i = 0; i < 8; i++ )
	{
		wnp = wns[i];
		xs = i * 3 + 12, ys = i + 5;
		wn_create( xs, ys, xs + 31, ys + 9, SGL_BDR, WN_NORMAL, wnp );
		wn_color( WHITE,  i % 8, wnp );
		wn_bdr_color( WHITE, i % 8, wnp );
		sprintf(buff, "<< Window %d >>", i + 1 );
		wn_name(names[i], wnp);
		add_window(wnp);
		for( x = 0; x < 8; x++ )
		{
			sprintf(buff, "Window %d, Line %d", i, x );
			wn_plst( 0, x, buff, wnp );
		}
	}
	for( x = 0; x < 32; x++ )
	{
		for( i = 0; i < 8; i++ )
		{
			new_att = ((((x + i + 1) % 8)) << 4) | WHITE;
			old_att = (((x + i) % 8) << 4) | WHITE;
			wn_bdratt(new_att, wns[i]);
			wn_change_att( new_att, old_att, wns[i] );
		}
	}
	wn_prompt("We can bring any window to the Top...");
	for( i = 7; i >= 0; i-- )
		make_top_window(wns[random(7)]);
	for( i = 7; i >= 0; i-- )
		make_top_window(wns[i]);
	for( i = 0; i < 8; i++ )
	{
		remove_window(wns[i]);
		wn_destroy(wns[i]);
	}
}
/*** end of wn_color_demo ***/

/*******************/
/* ~wn_create_demo */
/*                 **********************************************************/
/****************************************************************************/
wn_create_demo()
{
	int i, j, x, xs, ys, xe, ye;
	char buff[81];
	WINDOW *wns[NUM_WINS], *wnp;

	wn_color( YELLOW, BLUE, &Main_wn );
	wn_clear(&Main_wn);
	for( i = 0; i < 10; i++ )
	{
		mv_cs(20, i + 4, &Main_wn);
		wn_printf(&Main_wn, "This is line %d........", i + 1 );
	}
	wn_prompt("Let's dynamically allocate, create, and set 26 POPUP windows.");
	for( x = 0; x < NUM_WINS; x++ )
		if( (wns[x] = calloc(1,sizeof(WINDOW))) == NULL )
			return(0);
	x = 0;
	for( i = 0; i < 5; i++ )
	{
		for( j = 0; j < 4; j++, x++ )
		{
			switch( j )
			{
				case 0: xs =      i * 6; ys =      i + 3; break;
				case 1: xs = 60 - i * 6; ys =      i + 3; break;
				case 2: xs =      i * 6; ys = 20 - i; 		break;
				case 3: xs = 60 - i * 6; ys = 20 - i;		  break;
			}
			wnp = wns[x];
			wn_create( xs, ys, xs + 19, ys + 5, SGL_BDR, WN_POPUP,wnp );
			wn_color( WHITE, j + 2, wnp );
			wn_bdr_color( WHITE, j + 2, wnp );
			sprintf(buff, "<< Window %d >>", x + 1 );
			wn_name(buff, wnp);
			wn_set(wnp);
			wn_plst(CENTERED, 0, buff, wnp);
		}
	}
	for( i = 0; i < 12; i += 2, x++ )
	{
		wnp = wns[x];
		xs = 32 - i * 2, ys = 12 - i / 2;
		xe = 47 + i * 2, ye = 15 + i / 2;
		wn_create(xs, ys, xe, ye, SGL_BDR, WN_POPUP, wnp);
		wn_color( WHITE, i % 8, wnp );
		wn_bdr_color( WHITE, i % 8, wnp );
		sprintf(buff, "<< Window %d >>", x + 1 );
		wn_name(buff, wnp);
		wn_set(wnp);
	}
	wn_plst( CENTERED, 5, "Note that these are POPUP windows.", wnp );
	wn_plst( CENTERED, 6, "Everything below them is saved.", wnp );
	wn_plst( CENTERED, 7, "Watch closely as they are removed.", wnp );
	wn_plst( CENTERED, 9, "<<< Don't blink or you will miss it >>>!", wnp );
	wait();
	while( x-- > 0 )
		wn_destroy(wns[x]);
	wait();
}
/*** end of wn_create_demo ***/

/*******************/
/* ~wn_scroll_demo */
/*                 **********************************************************/
/****************************************************************************/
wn_scroll_demo()
{
	int i, t, x, a, r;
	WINDOW wn, wn1, wn2;

	wn_clear(&Main_wn);
	/*--------------------- demonstrate scrolling speed ----------------------*/
	wn_prompt("UltraWin has full window scrolling capabilities....");
	wn_create( 15, 9, 59, 17, SGL_BDR, WN_NORMAL, &wn );
	wn_color( YELLOW, RED, &wn );
	wn_bdr_color( YELLOW, RED, &wn );
	wn_name("Scrolling Window 1", &wn);
	add_window(&wn);
	for( t = 0; t < 2; t++ )
	{
		for( i = 0; i < 100; i++ )
		{
			wn.att &= 0xf0;
			wn.att |= random(16);
			wn_st("UltraWin Library ", &wn );
			if( t == 0 )
			wait_ticks( (clock_t) 1 );
		}
		if( t == 0 )
			wn_prompt("Too slow? Let's try it at full speed!");
	}
	/*------------------------- scroll up and down ---------------------------*/
	wn_prompt("There's more. UltraWin can scroll down...");
	wn_color( YELLOW, RED, &wn );
	wn_clear(&wn);
	for( i = 0; i < 7; i++ )
	{
		mv_cs( 0, i, &wn );
		wn_printf(&wn, "Line %d.....", i + 1 );
	}
	mv_cs(0,0,&wn);
	for( i = 0; i < 7; i++ )
	{
		wn_csr_up(1,&wn);
		wait_ticks( (clock_t) 2 );
	}
	wn_prompt("or UltraWin can scroll up.");
	wn_clear(&wn);
	for( i = 0; i < 7; i++ )
	{
		mv_cs( 0, i, &wn );
		wn_printf(&wn, "Line %d.....", i + 1 );
	}
	for( i = 0; i < 7; i++ )
	{
		wn_csr_dn(1,&wn);
		wait_ticks( (clock_t) 2 );
	}
	/*-------------------------- scrolling regions ---------------------------*/
	wn_prompt("You can also set a scrolling region within a window...");
	wn_color( YELLOW, RED, &wn );
	wn_clear(&wn);
	for( i = 0; i < 7; i++ )
	{
		mv_cs( 0, i, &wn );
		wn_printf(&wn, "Line %d.....", i + 1 );
	}
	wn_scroll_reg( 3, 6, &wn );
	wn_color(WHITE, RED, &wn);
	mv_cs(0, 3, &wn);
	for( i = 0; i < 100; i++ )
	{
		wn_st("UltraWin ", &wn );
		wait_ticks( (clock_t) 2 );
	}
	/*-------------------------- scroll multiples ---------------------------*/
	wn_prompt("UltraWin can scroll multiple windows concurrently!");
	wn_create( 12, 12, 49, 18, SGL_BDR, WN_NORMAL, &wn1 );
	wn_color( WHITE, GREEN, &wn1 );
	wn_bdr_color( WHITE, GREEN, &wn1 );
	wn_name("Scrolling Window 2", &wn1);
	wn_create( 18, 4, 69, 14, SGL_BDR, WN_NORMAL, &wn2 );
	wn_color( RED, BLACK, &wn2 );
	wn_bdr_color( RED, BLACK, &wn2 );
	wn_name("Scrolling Window 3", &wn2);

	add_window(&wn1);
	add_window(&wn2);
	for( t = 0; t < 2; t++ )
	{
		for( i = 0; i < 100; i++ )
		{
			wn_st("Window 1 output ",&wn);
			wn_st("Window 2 output ",&wn1);
			wn_st("Window 3 output ",&wn2);
			if( t == 0 )
				wait_ticks( (clock_t) 1 );
		}
		if( t == 0 )
			wn_prompt("Too slow? Let's try it at full speed!");
	}
	/*----------------- scroll multiples while moving! -----------------------*/
	wn_prompt("UltraWin can scroll multiple windows while moving!");
	for( i = 0; i < 50; i++ )
	{
		wn_st("Window 1 output ",&wn);
		wn_st("Window 2 output ",&wn1);
		wn_st("Window 3 output ",&wn2);
		x = random(10);
		if( x == 1 )
		{
			if( wn.pane.x_min > 0 )
				wn.pane.x_min--, wn.pane.x_max--, r = 1;
		}
		else if( x == 2 )
		{
			if( wn1.pane.y_min > 4 )
				wn1.pane.y_min--, wn1.pane.y_max--, r = 1;
			if( wn1.pane.x_max < V_cols )
				wn1.pane.x_min++, wn1.pane.x_max++, r = 1;
		}
		else if( x == 3 )
		{
			if( wn2.pane.y_max < V_rows )
				wn2.pane.y_min++, wn2.pane.y_max++, r = 1;
			if( wn2.pane.x_max < V_cols )
				wn2.pane.x_min++, wn2.pane.x_max++, r = 1;
		}
		if( r )
		{
			reset_all_masks();					/* reset all masks and redraw all windows */
			refresh_desktop();       	  /* since we are moving windows NOT on top */
		}                           	/* if the window was always on top, we can*/
	}                            	  /* simply use move_wn_up, etc...					*/
	remove_window(&wn);
	remove_window(&wn1);
	remove_window(&wn2);
}
/*** end of wn_scroll_demo ***/

/**************/
/* ~wn_prompt */
/*            ***************************************************************/
/****************************************************************************/
wn_prompt( char *prompt )
{
	WINDOW wn;

	wn_create( 0, 0, 79, 2, DBL_BDR, WN_NORMAL, &wn );
	wn_color( RED, LIGHTGRAY, &wn );
	wn_bdr_color( WHITE, BLACK, &wn );
	wn_set(&wn);
	wn_plst( CENTERED, 0, prompt, &wn );
	wait();
	wn_destroy(&wn);
}
/*** end of wn_prompt ***/

/*********/
/* ~wait */
/*       ********************************************************************/
/****************************************************************************/
wait()
{
	push(Main_wn.att);
	wn_color( WHITE, RED, &Main_wn ); 
	mv_cs(0,21,&Main_wn);
	wn_cleol(&Main_wn);
	wn_plst(CENTERED, 21, "Hit any key to continue...", &Main_wn);
	wait_event();
	pop(Main_wn.att);
	mv_cs(0,21,&Main_wn);
	wn_cleol(&Main_wn);
}
/*** end of wn_prompt ***/

/*****************/
/* ~title_screen */
/*               ************************************************************/
/* This routine does the UltraCom title screen, logo and subscription info	*/
/****************************************************************************/
char	*Title_strs[10] =
{
"                                   ",
" ۱   ۱ ۱  ۱ ۱۱ ۱۱    ۱    ۱ ۱ ۰   ۱  ",
" ۱  ۱۱  ۱۱۱۱۱   ۱   ۱۱۱۰  ۱ ",
" ۱  ۱۱   ۱   ۱  ۱۱  ۱   ۱   ۱۱۱۰ ۱ ",
" ۱  ۱۱   ۱   ۱۱   ۱   ۱۱۱ ۰۱ ",
" ۱  ۱۱   ۱   ۱۱۱۱   ۱   ۱۱۱  ۱ ",
" ۱  ۱۱   ۱   ۱۰۱۱   ۱ ۱۱۱  ۱ ",
"  ۱  ۱   ۱    ۱  ۱    ۱۱۱۱    ۱ ",
"                                ",
"                                           "
};
char	*Wave_strs[7] =
{
"            Source Available          Extended Mode Support                 ",
"                                                             Small          ",
" Ŀ       Menusͻ     [Data Entry]                              ",
"  Windows       1) Small        $12.34              FastFlexible ",
"       2) Fast         09/29/90                               ",
"                  ͼ     (123) 555-1212            Compatible       ",
"   Buffered Windows                          Mouse Support                  "
};
char	*Info_strs[5] =
{
"UltraWin! Version 1.10 by EnQue Software (Kevin Huck and Boyd Gafford)",
"Please send $20.00 to register, or $30.00 for source code to",
"Enque Software ",
"Route #1, Box 116C ",
"Pleasant Hill, Mo. 64080"
};
title_screen()
{
	register	int i, r, c, c1 = 7, c2 = (c1 + 9) % 16;
	int				x_off = (V_cols / 2) - 39;
	int				y_off = (V_rows / 2) - 8;
	int				len = strlen(Wave_strs[0]);
	int				w_off = 0;
	WINDOW		u_wn, b_wn;
	uchar			b = 0, *mask, *src;
	char			temp_str[40];
	clock_t		old_tics = 0;


	wn_create(x_off, y_off, x_off + 77, y_off + 13, DBL_BDR, WN_POPUP, &b_wn);
	b_wn.att = b_wn.bdr_att = (c1 << 4) | WHITE;
	wn_set( &b_wn);
	wn_create(x_off, y_off, x_off + 77, y_off + 13, NO_BDR, WN_NORMAL, &u_wn);
	u_wn.att = u_wn.bdr_att = (c1 << 4) | c2;
	wn_set( &u_wn);
  wn_border(&b_wn);
	u_wn.scroll = b_wn.scroll = OFF;
	mv_cs(1, 1, &u_wn);
	wn_qch(len, ' ', &u_wn);
	for (i=0; i<10; i++)
		wn_plst(1, i + 2, Title_strs[i], &u_wn);
	mv_cs(1, 12, &u_wn);
	wn_qch(len, ' ', &u_wn);

	mask = b_wn.mask;
	src =  u_wn.buff;
	for( r = 0; r < b_wn.rows; r++ )
		for( c = 0; c < b_wn.cols; c++, mask++, src+=2 )
			if ( ((*src != ' ') && (*src != 0)) )
				*mask += 1;
	b_wn.mask_on = ON;
	for (i=0; i<5; i++)
		wn_plst(CENTERED, 16 + i, Info_strs[i], &Main_wn);
	while ( !check_key() )
	{
		if (clock() != old_tics)
		{
			old_tics = clock();
			if ((++b) >= len)
			{
				b = 0;
				c1 = (c1 + 1) % 8;
				c2 = (c1 + 9) % 16;
				b_wn.att = b_wn.bdr_att = (c1 << 4) | WHITE;
				wn_border(&b_wn);
				u_wn.att = (c1 << 4) | c2;
				mv_cs(1, 1, &u_wn);
				wn_qch(len, ' ', &u_wn);
				for (i=0; i<10; i++)
					wn_plst(1, i + 2, Title_strs[i], &u_wn);
				mv_cs(1, 12, &u_wn);
				wn_qch(len, ' ', &u_wn);
				if( ++w_off >= 6 )
					w_off = 0;
			}
			for( i = 0; i < 7; i++ )
			{
				mv_cs(0, i + w_off, &b_wn);
				if (len - b)
					wn_st_qty(&Wave_strs[i][b], len - b, &b_wn);
				if (b)
					wn_st_qty(&Wave_strs[i][0], b, &b_wn);
			}
		}
	}
	wait_event();
	wn_clear(&u_wn);
	wn_border(&b_wn);
	for( i = 0; i < 7; i++ )
		wn_plst(1, i + 3, &Wave_strs[i][0], &u_wn);
	wait();
	wn_clear(&Main_wn);
	wn_destroy(&u_wn);
	wn_destroy(&b_wn);
}

/*****************/
/* ~wn_menu_demo */
/*               ************************************************************/
/* This routine demonstrates UltraWin's menuing capabilities... 						*/
/* the main polling loop!																										*/
/****************************************************************************/
wn_menu_demo()
{
	int id, i,
			back_att	= (LIGHTGRAY << 4) | BLACK,
			bdr_att		= (LIGHTGRAY << 4) | BLACK,
			csr_att		= (CYAN << 4) | YELLOW,
			first_att	= (LIGHTGRAY << 4) | RED;

	wn_clear(&Main_wn);
/*--------------------- demonstrate menuing capabilities -------------------*/
	wn_prompt("Use the arrow keys or your mouse to traverse the menu tree!");

/*-------------------------- create top menu -------------------------------*/
	menu_create(0, 4, V_cols - 1, 3, M_HORIZONTAL,
							back_att, bdr_att, csr_att, first_att,
							NO_BDR, WN_NORMAL, Top_mnp);
	item_add( "   Files   ", 1, 3, &Top_menu );
	item_add( " Terminals ", 2, 1, &Top_menu );
	item_add( "   Setup   ", 3, 3, &Top_menu );
	item_add( "  Windows  ", 4, 2, &Top_menu );

	Drop_mnps[0] = &Files_menu;
	Drop_mnps[1] = &Terminal_menu;
	Drop_mnps[2] = &Setup_menu;
	Drop_mnps[3] = &Window_menu;
/*------------------------- create file menu -------------------------------*/
	menu_create(0, 5, 21, 12, M_VERTICAL,
		back_att, bdr_att, csr_att, first_att,
		SGL_BDR, WN_NORMAL, Drop_mnps[0]);
	item_add( " Text Editor   Alt-E",	5, 6, &Files_menu );
	item_add( " Hex Editor    Alt-H",	6, 1, &Files_menu );
	item_add( " File Manager  Alt-F",	7, 1, &Files_menu );
	item_add( " Calculator    Alt-C",	8, 1, &Files_menu );
	item_add( " Dos Shell     Alt-O",	9, 5, &Files_menu );
	item_add( " Quit          Alt-Q",10, 1, &Files_menu );

/*------------------------ create terminal menu ----------------------------*/
	menu_create(11, 5, 32, 11, M_VERTICAL,
	 back_att, bdr_att, csr_att, first_att, SGL_BDR, WN_NORMAL, Drop_mnps[1]);
	item_add( " Add Terminal  Alt-T",	 11, 1, &Terminal_menu );
	item_add( " Settings      Alt-F6", 12, 1, &Terminal_menu );
	item_add( " Receive File  Alt-F7", 13, 1, &Terminal_menu );
	item_add( " Transmit File Alt-F8", 14, 1, &Terminal_menu );
	item_add( " Comm Status   Alt-S",	 15, 6, &Terminal_menu );

/*--------------------------- create setup menu ----------------------------*/
	menu_create(22, 5, 43,10, M_VERTICAL,
		back_att, bdr_att, csr_att, first_att, SGL_BDR, WN_NORMAL, Drop_mnps[2]);
	item_add( " Mouse Setup        ",	16, 1, &Setup_menu);
	item_add( " Video Mode    Alt-V", 17, 1, &Setup_menu );
	item_add( " Window Color  Alt-W",	18, 1, &Setup_menu );
	item_add( " Border Color  Alt-B", 19, 1, &Setup_menu );

/*--------------------------- create window menu ---------------------------*/
	menu_create(33, 5, 48, 9, M_VERTICAL,
		back_att, bdr_att, csr_att, first_att,  SGL_BDR, WN_NORMAL, Drop_mnps[3]);
	item_add( " Delete  Alt-D",	20, 1, &Window_menu );
	item_add( " Size    Alt-S",	21, 1, &Window_menu );
	item_add( " Move    Alt-M",	22, 1, &Window_menu );

/*------------------------------ let's roll --------------------------------*/
	wn_create( 0, 4, V_cols - 1, V_rows - 4, SGL_BDR, WN_NORMAL, Back_wnp );
	wn_color( WHITE, RED, Back_wnp );
	wn_bdr_color( WHITE, RED, Back_wnp );
	add_window(Back_wnp);
	wn_plst(0,0, "UltraWin is a powerful, easy to use window library", Back_wnp);
	wn_plst(0,1, "with flexible data entry and menu capabilities... ", Back_wnp);

	menu_set(Top_mnp);
	m_show();
	set_idle_func(tmp);
	id = menu_system(Top_mnp, Drop_mnps, 0);
	set_idle_func(NULL);

	m_hide();
	menu_restore(Top_mnp);
	menu_destroy(Top_mnp);														/* destroy all menus!		*/
	for( i = 0; i < 4; i++ )
		menu_destroy(Drop_mnps[i]);
	remove_window(Back_wnp);													/* background window    */
	return(id);
}
/*** end of wn_menu_demo ***/

int tmp()
{
	static int now, last;
	int att;

	now = clock();
	if ( (now < last) || ((now - last) > 2) )
	{
		last = now;
		att = Back_wnp->att & 0x0f;											/* roll through colors  */
		att = (att + 1) % 16;
		if( att == RED )
			att = (att + 1) % 16;
		Back_wnp->att &= 0xf0;
		Back_wnp->att |= att;
		m_hide();
		wn_st("UltraWin Library. Power, Speed, Ease!   ", Back_wnp );
		m_show();
	}
}

/******************/
/* ~wn_change_att */
/*                ***********************************************************/
/* This routine changes the color of a window...                						*/
/* This demonstrates low level window control...														*/
/****************************************************************************/
wn_change_att(int new_att, int old_att, WINDOW *wnp)
{
	int i, cnt;
	uchar *dest = wnp->buff;
	old_att  = get_att(old_att);
	new_att  = get_att(new_att);

	cnt = wnp->rows * wnp->cols;
	dest++;
	for( i = 0; i < cnt; i++, dest += 2 )
		if( *dest == old_att )
			*dest = new_att;
	wn_border( wnp );
	wn_rfsh( wnp );
}
/*** end of wn_change_att ***/

/**** END OF FILE ****/
