/****************************************************************************/
/*																																					*/
/* UW_GLOBX.H 																															*/
/*																																					*/
/* This module contains all the externs used by the UltraWIN library.       */
/*																																					*/
/*																													Kevin Huck			*/
/*																													Boyd Gafford		*/
/*																																					*/
/****************************************************************************/
#include <conio.h>

extern int					Num_windows;				/* number of open windows on desk!	*/
extern uchar far		*Screen;						/* ponter to physical screen loc		*/

extern uchar				V_cols;							/* columns on the video screen			*/
extern uchar				V_rows;							/* rows on the video screen					*/
extern int 					V_mode;							/* old video mode!									*/

extern int					DV_seg;							/* Desqview variables								*/
extern int					DV_off;
extern int					DV_flag;
extern int					DV_upd;

extern uchar 				Dflt_att; 					/* default colors for windows				*/
extern uchar 				Dflt_bdr_att;

extern int					Stack[64];
extern int					Stack_ptr;					/* stack to save wn states					*/
extern int					Csr_visible;				/* is the cursor visible						*/
extern int					Csr_in_use;					/* is the cursor used by a popup?		*/

extern EVENT				Event;							/* the global event variable        */
extern int					Mouse_exists;				/* is the mouse available or not?		*/

extern WINDOW				*First_window;			/* manager first window pointer			*/
extern WINDOW				*Last_window;				/* manager last window pointer			*/
